module Gandi
  class FaultCode
    class Data < FaultCode
      QUALIF = 5
      ERROR = Gandi::DataError

      OBJECT = {
        0 => :object_unknown,
        1 => :object_password,
        2 => :object_session,
        3 => :object_login,
        10 => :object_integer,
        11 => :object_boolean,
        12 => :object_string,
        13 => :object_date,
        14 => :object_list,
        15 => :object_struct,
        16 => :object_method,
        17 => :object_key,
        18 => :object_float,
        19 => :object_duration,
        50 => :object_email,
        51 => :object_url,
        52 => :object_fqdn,
        53 => :object_ipv4,
        54 => :object_web_redirection,
        55 => :object_transfer,
        56 => :object_transferout,
        57 => :object_ipv6,
        58 => :object_cidr,
        100 => :object_domain,
        101 => :object_account,
        102 => :object_operation,
        103 => :object_mailbox,
        104 => :object_forward,
        105 => :object_mailzone,
        106 => :object_host,
        107 => :object_status,
        108 => :object_dnssec_key,
        109 => :object_mail,
        110 => :object_reachability,
        111 => :object_claims,
        140 => :object_company_name,
        141 => :object_body_name,
        142 => :object_association_name,
        150 => :object_phone,
        151 => :object_french_department,
        152 => :object_country_code,
        153 => :object_contact_type,
        154 => :object_contact_class,
        155 => :object_iso_language,
        156 => :object_contact_lang,
        157 => :object_state_code,
        160 => :object_auth_code,
        161 => :object_contact,
        162 => :object_corpo,
        163 => :object_lang,
        164 => :object_registry,
        165 => :object_eoi,
        166 => :object_tld,
        167 => :object_phase,
        168 => :object_changeowner,
        169 => :object_reseller,
        170 => :object_sudo,
        200 => :object_redirection_type,
        201 => :object_buyrenew_period,
        210 => :object_autorenew,
        211 => :object_prepaid,
        212 => :object_transaction,
        220 => :object_packmail,
        230 => :object_document,
        231 => :object_documentrequest,
        232 => :object_ssl,
        233 => :object_country,
        234 => :object_auto_credit,
        235 => :object_smd,
        236 => :object_zip,
        237 => :object_goodie,
        238 => :object_autofoa,
        239 => :object_delete,
        240 => :object_foa,
        250 => :object_operation_state,
        251 => :object_operation_type,
        252 => :object_operation_event,
        300 => :object_hosting_account,
        302 => :object_vm,
        303 => :object_meta,
        304 => :object_disk,
        305 => :object_os,
        306 => :object_meta_conf,
        307 => :object_vm_conf,
        308 => :object_vm_ip,
        309 => :object_vm_shares,
        310 => :object_flex,
        311 => :object_flex_shares,
        312 => :object_flex_date_start,
        313 => :object_flex_date_end,
        314 => :object_flex_op,
        315 => :object_flex_action,
        316 => :object_vm_trigger,
        317 => :object_iface,
        318 => :object_ip,
        319 => :object_bandwidth,
        320 => :object_lb,
        321 => :object_lbserver,
        322 => :object_lbfarm,
        323 => :object_lblistener,
        324 => :object_snapshot,
        325 => :object_image,
        326 => :object_lbconfiglistener,
        327 => :object_datacenter,
        350 => :object_hosting_account_status,
        351 => :object_hosting_product,
        375 => :object_paas,
        376 => :object_virtualhost,
        377 => :object_vlan,
        378 => :object_snapshot_profile,
        379 => :object_rproxy,
        401 => :object_certificate,
        402 => :object_csr,
        403 => :object_package,
        404 => :object_cn,
        405 => :object_wildcard,
        406 => :object_altname,
        407 => :object_joi,
        408 => :object_cert_ida,
        409 => :object_dcv,
        600 => :object_site,
        601 => :object_site_host,
        602 => :object_gandi_site_host,
        603 => :object_user,
        604 => :object_sitemaker_error,
        605 => :object_site_host_ip,
        606 => :object_site_offer,
        607 => :object_site_name,
        608 => :object_site_count,
        609 => :object_site_key,
        700 => :object_tva,
        701 => :object_currency,
        702 => :object_catalog_entry,
        703 => :object_promo_code,
        704 => :object_coupon_code,
        705 => :object_pricer_duration,
        706 => :object_pricer_quantity,
        707 => :object_refund,
        708 => :object_fee,
        709 => :object_bill_item,
        710 => :object_product,
        711 => :object_bill,
        712 => :object_payment,
        713 => :object_action_type,
        714 => :object_description,
        715 => :object_quantity,
        716 => :object_contact_pref,
        717 => :object_domain_pref,
        718 => :object_contract,
        719 => :object_totp,
        720 => :object_postit,
        721 => :object_postit_object_type,
        722 => :object_business_unit,
        723 => :object_grid,
        724 => :object_paymenttype,
        800 => :object_dns_cname,
        801 => :object_dns_txt,
        802 => :object_dns_address,
        803 => :object_dns_a,
        804 => :object_dns_aaaa,
        805 => :object_dns_mx,
        806 => :object_dns_spf,
        810 => :object_zone,
        811 => :object_dns_record,
      }
      CAUSE = {
        0 => :cause_unknown,
        1 => :cause_no_kernel,
        2 => :cause_cmdline_opt,
        10 => :cause_type,
        20 => :cause_syntax,
        23 => :cause_corporate,
        30 => :cause_value,
        31 => :cause_size,
        32 => :cause_expected,
        33 => :cause_unexpected,
        34 => :cause_identical,
        35 => :cause_quota_reached,
        36 => :cause_name,
        37 => :cause_badparameter,
        38 => :cause_hostname,
        39 => :cause_attached,
        40 => :cause_dontexist,
        41 => :cause_exist,
        42 => :cause_notfound,
        43 => :cause_no_result,
        44 => :cause_nothing_to_update,
        45 => :cause_position,
        46 => :cause_no_disk,
        47 => :cause_invalid_phase,
        48 => :cause_conf,
        49 => :cause_expired,
        50 => :cause_noright,
        51 => :cause_datacenter,
        52 => :cause_multiple_results,
        53 => :cause_query,
        54 => :cause_disabled,
        55 => :cause_price,
        56 => :cause_authinfo,
        60 => :cause_state,
        61 => :cause_order_not_done,
        62 => :cause_billed,
        63 => :cause_not_enough_money,
        64 => :cause_currency_mismatch,
        65 => :cause_quantity_or_period_null,
        66 => :cause_failure,
        67 => :cause_pending,
        68 => :cause_running,
        69 => :cause_attached_running,
        70 => :cause_incompatibility,
        71 => :cause_vm_meta_incompatibility,
        72 => :cause_os_meta_incompatibility,
        73 => :cause_metas_incompatibility,
        74 => :cause_vmshares_meta_incompatibility,
        75 => :cause_meta_dependencies,
        81 => :cause_not_configured,
        90 => :cause_invalid_step,
        91 => :cause_invalid,
        92 => :cause_invalid_resource,
        93 => :cause_currency,
        94 => :cause_epperror,
        95 => :cause_cannot_shrink,
        96 => :cause_ip_version_mismatch,
        97 => :cause_version,
        98 => :cause_not_attached,
        99 => :cause_toomany,
      }
    end
  end
end
